diff --git a/src/gui/image/qimage_conversions.cpp b/src/gui/image/qimage_conversions.cpp
index 28e3a48..4c99917 100644
--- a/src/gui/image/qimage_conversions.cpp
+++ b/src/gui/image/qimage_conversions.cpp
@@ -168,6 +168,32 @@ void convert_generic(QImageData *dest, const QImageData *src, Qt::ImageConversio
     }
 }
 
+void convert_generic_to_rgb64(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(dest->format == QImage::Format_RGBA64_Premultiplied);
+    Q_ASSERT(src->format > QImage::Format_Indexed8);
+    const int buffer_size = 2048;
+    quint64 buffer[buffer_size];
+    const QPixelLayout *srcLayout = &qPixelLayouts[src->format];
+    const uchar *srcData = src->data;
+    uchar *destData = dest->data;
+
+    const FetchPixelsFunc64 fetch64 = qFetchPixels64[srcLayout->bpp];
+    ConvertFunc64 convertToRGBA64PM = srcLayout->convertToRGBA64PM;
+
+    for (int y = 0; y < src->height; ++y) {
+        int x = 0;
+        while (x < src->width) {
+            int l = qMin(src->width - x, buffer_size);
+            const quint64 *ptr = fetch64(buffer, srcData, x, l);
+            convertToRGBA64PM((QRgba64*)destData + x, ptr, l, srcLayout, 0);
+            x += l;
+        }
+        srcData += src->bytes_per_line;
+        destData += dest->bytes_per_line;
+    }
+}
+
 bool convert_generic_inplace(QImageData *data, QImage::Format dst_format, Qt::ImageConversionFlags)
 {
     // Cannot be used with indexed formats or between formats with different pixel depths.
@@ -182,6 +208,8 @@ bool convert_generic_inplace(QImageData *data, QImage::Format dst_format, Qt::Im
     const QPixelLayout *destLayout = &qPixelLayouts[dst_format];
     uchar *srcData = data->data;
 
+    Q_ASSERT(srcLayout->bpp == destLayout->bpp);
+    Q_ASSERT(srcLayout->bpp != QPixelLayout::BPP64);
     const FetchPixelsFunc fetch = qFetchPixels[srcLayout->bpp];
     const StorePixelsFunc store = qStorePixels[destLayout->bpp];
     ConvertFunc convertToARGB32PM = srcLayout->convertToARGB32PM;
@@ -1009,6 +1037,270 @@ static void mask_alpha_converter_RGBx(QImageData *dest, const QImageData *src, Q
 #endif
 }
 
+template<bool RGBA>
+static void convert_RGBA64_to_ARGB32(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(src->format == QImage::Format_RGBA64);
+    Q_ASSERT(RGBA || dest->format == QImage::Format_ARGB32);
+    Q_ASSERT(!RGBA || dest->format == QImage::Format_RGBA8888);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const uchar *srcData = src->data;
+    uchar *destData = dest->data;
+
+    for (int i = 0; i < src->height; ++i) {
+        uint *d = reinterpret_cast<uint *>(destData);
+        const QRgba64 *s = reinterpret_cast<const QRgba64 *>(srcData);
+        qt_convertRGBA64ToARGB32<RGBA>(d, s, src->width);
+        srcData += src->bytes_per_line;
+        destData += dest->bytes_per_line;
+    }
+}
+
+template<bool RGBA>
+static void convert_RGBA64PM_to_ARGB32(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(src->format == QImage::Format_RGBA64_Premultiplied);
+    Q_ASSERT(RGBA || dest->format == QImage::Format_ARGB32);
+    Q_ASSERT(!RGBA || dest->format == QImage::Format_RGBA8888);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const int src_pad = (src->bytes_per_line >> 3) - src->width;
+    const int dest_pad = (dest->bytes_per_line >> 2) - dest->width;
+    const QRgba64 *src_data = reinterpret_cast<const QRgba64 *>(src->data);
+    uint *dest_data = reinterpret_cast<uint *>(dest->data);
+
+    for (int i = 0; i < src->height; ++i) {
+        const QRgba64 *end = src_data + src->width;
+        while (src_data < end) {
+            QRgba64 s = src_data->unpremultiplied();
+            *dest_data = RGBA ? ARGB2RGBA(s.toArgb32()) : s.toArgb32();
+            ++src_data;
+            ++dest_data;
+        }
+        src_data += src_pad;
+        dest_data += dest_pad;
+    }
+}
+
+template<bool RGBA>
+static void convert_ARGB32_to_RGBA64(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(RGBA || src->format == QImage::Format_ARGB32);
+    Q_ASSERT(!RGBA || src->format == QImage::Format_RGBA8888);
+    Q_ASSERT(dest->format == QImage::Format_RGBA64);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const int src_pad = (src->bytes_per_line >> 2) - src->width;
+    const int dest_pad = (dest->bytes_per_line >> 3) - dest->width;
+    const uint *src_data = reinterpret_cast<const uint *>(src->data);
+    QRgba64 *dest_data = reinterpret_cast<QRgba64 *>(dest->data);
+
+    for (int i = 0; i < src->height; ++i) {
+        const uint *end = src_data + src->width;
+        while (src_data < end) {
+            if (RGBA)
+                *dest_data = QRgba64::fromArgb32(RGBA2ARGB(*src_data));
+            else
+                *dest_data = QRgba64::fromArgb32(*src_data);
+            ++src_data;
+            ++dest_data;
+        }
+        src_data += src_pad;
+        dest_data += dest_pad;
+    }
+}
+
+template<QtPixelOrder PixelOrder>
+static void convert_RGBA64PM_to_RGB30(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(src->format == QImage::Format_RGBA64_Premultiplied);
+    Q_ASSERT(dest->format == QImage::Format_RGB30 || dest->format == QImage::Format_BGR30);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const int src_pad = (src->bytes_per_line >> 3) - src->width;
+    const int dest_pad = (dest->bytes_per_line >> 2) - dest->width;
+    const QRgba64 *src_data = reinterpret_cast<const QRgba64 *>(src->data);
+    uint *dest_data = reinterpret_cast<uint *>(dest->data);
+
+    for (int i = 0; i < src->height; ++i) {
+        const QRgba64 *end = src_data + src->width;
+        while (src_data < end) {
+            *dest_data = 0xc0000000 || qConvertRgb64ToRgb30<PixelOrder>(src_data->unpremultiplied());
+            ++src_data;
+            ++dest_data;
+        }
+        src_data += src_pad;
+        dest_data += dest_pad;
+    }
+}
+
+template<QtPixelOrder PixelOrder>
+static void convert_RGBA64PM_to_A2RGB30(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(src->format == QImage::Format_RGBA64_Premultiplied);
+    Q_ASSERT(dest->format == QImage::Format_A2RGB30_Premultiplied
+          || dest->format == QImage::Format_A2BGR30_Premultiplied);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const int src_pad = (src->bytes_per_line >> 3) - src->width;
+    const int dest_pad = (dest->bytes_per_line >> 2) - dest->width;
+    const QRgba64 *src_data = reinterpret_cast<const QRgba64 *>(src->data);
+    uint *dest_data = reinterpret_cast<uint *>(dest->data);
+
+    for (int i = 0; i < src->height; ++i) {
+        const QRgba64 *end = src_data + src->width;
+        while (src_data < end) {
+            *dest_data = qConvertRgb64ToRgb30<PixelOrder>(*src_data);
+            ++src_data;
+            ++dest_data;
+        }
+        src_data += src_pad;
+        dest_data += dest_pad;
+    }
+}
+
+static void convert_RGBA64_to_RGBx64(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(src->format == QImage::Format_RGBA64);
+    Q_ASSERT(dest->format == QImage::Format_RGBX64);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const int src_pad = (src->bytes_per_line >> 3) - src->width;
+    const int dest_pad = (dest->bytes_per_line >> 3) - dest->width;
+    const QRgba64 *src_data = reinterpret_cast<const QRgba64 *>(src->data);
+    QRgba64 *dest_data = reinterpret_cast<QRgba64 *>(dest->data);
+
+    for (int i = 0; i < src->height; ++i) {
+        const QRgba64 *end = src_data + src->width;
+        while (src_data < end) {
+            *dest_data = *src_data;
+            dest_data->setAlpha(65535);
+            ++src_data;
+            ++dest_data;
+        }
+        src_data += src_pad;
+        dest_data += dest_pad;
+    }
+}
+
+static bool convert_RGBA64_to_RGBx64_inplace(QImageData *data, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(data->format == QImage::Format_RGBA64);
+
+    const int pad = (data->bytes_per_line >> 3) - data->width;
+    QRgba64 *rgb_data = reinterpret_cast<QRgba64 *>(data->data);
+
+    for (int i = 0; i < data->height; ++i) {
+        const QRgba64 *end = rgb_data + data->width;
+        while (rgb_data < end) {
+            rgb_data->setAlpha(65535);
+            ++rgb_data;
+        }
+        rgb_data += pad;
+    }
+    data->format = QImage::Format_RGBX64;
+    return true;
+}
+
+static void convert_RGBA64_to_RGBA64PM(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(src->format == QImage::Format_RGBA64);
+    Q_ASSERT(dest->format == QImage::Format_RGBA64_Premultiplied);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const int src_pad = (src->bytes_per_line >> 3) - src->width;
+    const int dest_pad = (dest->bytes_per_line >> 3) - dest->width;
+    const QRgba64 *src_data = reinterpret_cast<const QRgba64 *>(src->data);
+    QRgba64 *dest_data = reinterpret_cast<QRgba64 *>(dest->data);
+
+    for (int i = 0; i < src->height; ++i) {
+        const QRgba64 *end = src_data + src->width;
+        while (src_data < end) {
+            *dest_data = src_data->premultiplied();
+            ++src_data;
+            ++dest_data;
+        }
+        src_data += src_pad;
+        dest_data += dest_pad;
+    }
+}
+
+static bool convert_RGBA64_to_RGBA64PM_inplace(QImageData *data, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(data->format == QImage::Format_RGBA64);
+
+    const int pad = (data->bytes_per_line >> 3) - data->width;
+    QRgba64 *rgb_data = reinterpret_cast<QRgba64 *>(data->data);
+
+    for (int i = 0; i < data->height; ++i) {
+        const QRgba64 *end = rgb_data + data->width;
+        while (rgb_data < end) {
+            *rgb_data = rgb_data->premultiplied();
+            ++rgb_data;
+        }
+        rgb_data += pad;
+    }
+    data->format = QImage::Format_RGBA64_Premultiplied;
+    return true;
+}
+
+template<bool MaskAlpha>
+static void convert_RGBA64PM_to_RGBA64(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(src->format == QImage::Format_RGBA64_Premultiplied);
+    Q_ASSERT(dest->format == QImage::Format_RGBA64 || dest->format == QImage::Format_RGBX64);
+    Q_ASSERT(src->width == dest->width);
+    Q_ASSERT(src->height == dest->height);
+
+    const int src_pad = (src->bytes_per_line >> 3) - src->width;
+    const int dest_pad = (dest->bytes_per_line >> 3) - dest->width;
+    const QRgba64 *src_data = reinterpret_cast<const QRgba64 *>(src->data);
+    QRgba64 *dest_data = reinterpret_cast<QRgba64 *>(dest->data);
+
+    for (int i = 0; i < src->height; ++i) {
+        const QRgba64 *end = src_data + src->width;
+        while (src_data < end) {
+            *dest_data = src_data->unpremultiplied();
+            if (MaskAlpha)
+                dest_data->setAlpha(65535);
+            ++src_data;
+            ++dest_data;
+        }
+        src_data += src_pad;
+        dest_data += dest_pad;
+    }
+}
+
+template<bool MaskAlpha>
+static bool convert_RGBA64PM_to_RGBA64_inplace(QImageData *data, Qt::ImageConversionFlags)
+{
+    Q_ASSERT(data->format == QImage::Format_RGBA64_Premultiplied);
+
+    const int pad = (data->bytes_per_line >> 3) - data->width;
+    QRgba64 *rgb_data = reinterpret_cast<QRgba64 *>(data->data);
+
+    for (int i = 0; i < data->height; ++i) {
+        const QRgba64 *end = rgb_data + data->width;
+        while (rgb_data < end) {
+            *rgb_data = rgb_data->unpremultiplied();
+            if (MaskAlpha)
+                rgb_data->setAlpha(65535);
+            ++rgb_data;
+        }
+        rgb_data += pad;
+    }
+    data->format = MaskAlpha ? QImage::Format_RGBX64 : QImage::Format_RGBA64;
+    return true;
+}
+
 static QVector<QRgb> fix_color_table(const QVector<QRgb> &ctbl, QImage::Format format)
 {
     QVector<QRgb> colorTable = ctbl;
@@ -1878,7 +2170,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_Mono
 
     {
@@ -1900,7 +2192,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_MonoLSB
 
     {
@@ -1925,6 +2217,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0, 0, 0, 0, 0,
         convert_Indexed8_to_Alpha8,
         convert_Indexed8_to_Grayscale8,
+        0, 0, 0
     }, // Format_Indexed8
 
     {
@@ -1951,7 +2244,8 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         convert_RGB_to_RGB30<PixelOrderBGR>,
         convert_RGB_to_RGB30<PixelOrderRGB>,
         convert_RGB_to_RGB30<PixelOrderRGB>,
-        0, 0
+        0, 0,
+        0, 0, 0
     }, // Format_RGB32
 
     {
@@ -1978,7 +2272,10 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         convert_RGB_to_RGB30<PixelOrderRGB>,
         0,
-        0, 0
+        0, 0,
+        0,
+        convert_ARGB32_to_RGBA64<false>,
+        0
     }, // Format_ARGB32
 
     {
@@ -2001,11 +2298,9 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         convert_ARGB_to_RGBA,
-        0,
-        0,
-        0,
-        0,
-        0, 0
+        0, 0, 0, 0,
+        0, 0,
+        0, 0, 0
     },  // Format_ARGB32_Premultiplied
 
     {
@@ -2027,7 +2322,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB16
 
     {
@@ -2049,7 +2344,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB8565_Premultiplied
 
     {
@@ -2071,7 +2366,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB666
 
     {
@@ -2093,7 +2388,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB6666_Premultiplied
 
     {
@@ -2115,7 +2410,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB555
 
     {
@@ -2137,7 +2432,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB8555_Premultiplied
 
     {
@@ -2160,7 +2455,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         convert_RGB888_to_RGB<true>,
         convert_RGB888_to_RGB<true>,
         convert_RGB888_to_RGB<true>,
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB888
 
     {
@@ -2182,7 +2477,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB444
 
     {
@@ -2203,7 +2498,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB4444_Premultiplied
     {
         0,
@@ -2223,9 +2518,9 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        mask_alpha_converter_RGBx,
-        mask_alpha_converter_RGBx,
-        0, 0, 0, 0, 0, 0
+        convert_passthrough,
+        convert_passthrough,
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGBX8888
     {
         0,
@@ -2252,7 +2547,10 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
 #endif
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0,
+        0,
+        convert_ARGB32_to_RGBA64<true>,
+        0
     }, // Format_RGBA8888
 
     {
@@ -2274,7 +2572,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGBA8888_Premultiplied
 
     {
@@ -2301,7 +2599,8 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         convert_passthrough,
         convert_BGR30_to_RGB30,
         convert_BGR30_to_RGB30,
-        0, 0
+        0, 0,
+        0, 0, 0
     }, // Format_BGR30
     {
         0,
@@ -2327,7 +2626,8 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         convert_BGR30_to_RGB30,
-        0, 0
+        0, 0,
+        0, 0, 0
     }, // Format_BGR30A2_Premultiplied
     {
         0,
@@ -2353,7 +2653,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         convert_passthrough,
-        0, 0
+        0, 0, 0, 0, 0
     }, // Format_RGB30
     {
         0,
@@ -2379,8 +2679,8 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         convert_BGR30_to_RGB30,
         convert_A2RGB30_PM_to_RGB30,
         0,
-        0,
-        0,
+        0, 0,
+        0, 0, 0
     }, // Format_RGB30A2_Premultiplied
     {
         0,
@@ -2400,7 +2700,7 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_Alpha8
     {
         0,
@@ -2420,20 +2720,98 @@ Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImageFormat
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0, 0
-    } // Format_Grayscale8
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+    }, // Format_Grayscale8
+    {
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0, 0, 0, 0,
+        0, 0,
+        0, // self
+        convert_passthrough,
+        convert_passthrough
+    }, // Format_RGBX64
+    {
+        0,
+        0,
+        0,
+        0,
+        0,
+        convert_RGBA64_to_ARGB32<false>,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        convert_RGBA64_to_ARGB32<true>,
+        0,
+        0, 0, 0, 0,
+        0, 0,
+        convert_RGBA64_to_RGBx64,
+        0, // self
+        convert_RGBA64_to_RGBA64PM
+    }, // Format_RGBA64
+    {
+        0,
+        0,
+        0,
+        0,
+        0,
+        convert_RGBA64PM_to_ARGB32<false>,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        0,
+        convert_RGBA64PM_to_ARGB32<true>,
+        0,
+        convert_RGBA64PM_to_RGB30<PixelOrderBGR>,
+        convert_RGBA64PM_to_A2RGB30<PixelOrderBGR>,
+        convert_RGBA64PM_to_RGB30<PixelOrderRGB>,
+        convert_RGBA64PM_to_A2RGB30<PixelOrderRGB>,
+        0, 0,
+        convert_RGBA64PM_to_RGBA64<true>,
+        convert_RGBA64PM_to_RGBA64<false>,
+        0 // self
+    } // Format_RGBA64_Premultiplied
 };
 
 InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QImage::NImageFormats] =
 {
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     },
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_Mono
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_MonoLSB
     {
         0,
@@ -2457,6 +2835,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0, 0, 0, 0, 0,
         convert_Indexed8_to_Alpha8_inplace,
         convert_Indexed8_to_Grayscale8_inplace,
+        0, 0, 0
     }, // Format_Indexed8
     {
         0,
@@ -2478,7 +2857,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB32
     {
         0,
@@ -2504,7 +2883,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         convert_ARGB_to_RGBA_inplace,
         0,
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB32
     {
         0,
@@ -2526,34 +2905,34 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         0,
         convert_ARGB_to_RGBA_inplace,
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     },  // Format_ARGB32_Premultiplied
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB16
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB8565_Premultiplied
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB666
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB6666_Premultiplied
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB555
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB8555_Premultiplied
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB888
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGB444
     {
-        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_ARGB4444_Premultiplied
     {
         0,
@@ -2575,7 +2954,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         convert_passthrough_inplace<QImage::Format_RGBA8888>,
         convert_passthrough_inplace<QImage::Format_RGBA8888_Premultiplied>,
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGBX8888
     {
         0,
@@ -2602,7 +2981,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         0,
 #endif
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGBA8888
     {
         0,
@@ -2624,7 +3003,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         0,
         0,
-        0, 0, 0, 0, 0, 0
+        0, 0, 0, 0, 0, 0, 0, 0, 0
     }, // Format_RGBA8888_Premultiplied
     {
         0,
@@ -2650,7 +3029,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         convert_passthrough_inplace<QImage::Format_A2BGR30_Premultiplied>,
         convert_BGR30_to_RGB30_inplace,
         convert_BGR30_to_RGB30_inplace,
-        0, 0
+        0, 0, 0, 0, 0
     }, // Format_BGR30
     {
         0,
@@ -2676,7 +3055,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         0,
         convert_BGR30_to_RGB30_inplace,
-        0, 0
+        0, 0, 0, 0, 0
     }, // Format_BGR30A2_Premultiplied
     {
         0,
@@ -2702,7 +3081,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         convert_BGR30_to_RGB30_inplace,
         0,
         convert_passthrough_inplace<QImage::Format_A2RGB30_Premultiplied>,
-        0, 0
+        0, 0, 0, 0, 0
     }, // Format_RGB30
     {
         0,
@@ -2728,7 +3107,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         convert_BGR30_to_RGB30_inplace,
         convert_A2RGB30_PM_to_RGB30_inplace,
         0,
-        0, 0
+        0, 0, 0, 0, 0
     }, // Format_RGB30A2_Premultiplied
     {
         0,
@@ -2754,7 +3133,7 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         0,
         0,
-        0, 0
+        0, 0, 0, 0, 0
     }, // Format_Alpha8
     {
         0,
@@ -2780,8 +3159,26 @@ InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QIma
         0,
         0,
         0,
-        0, 0
-    }  // Format_Grayscale8
+        0, 0, 0, 0, 0
+    }, // Format_Grayscale8
+    {
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+        0, // self
+        convert_passthrough_inplace<QImage::Format_RGBA64>,
+        convert_passthrough_inplace<QImage::Format_RGBA64_Premultiplied>,
+    }, // Format_RGBX64
+    {
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+        convert_RGBA64_to_RGBx64_inplace,
+        0, // self
+        convert_RGBA64_to_RGBA64PM_inplace
+    }, // Format_RGBA64
+    {
+        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+        convert_RGBA64PM_to_RGBA64_inplace<true>,
+        convert_RGBA64PM_to_RGBA64_inplace<false>,
+        0 // self
+    }  // Format_RGBA64_Premultiplied
 };
 
 void qInitImageConversions()
diff --git a/src/gui/image/qimage_p.h b/src/gui/image/qimage_p.h
index 7eb5719..8755d5b 100644
--- a/src/gui/image/qimage_p.h
+++ b/src/gui/image/qimage_p.h
@@ -107,6 +107,7 @@ extern Image_Converter qimage_converter_map[QImage::NImageFormats][QImage::NImag
 extern InPlace_Image_Converter qimage_inplace_converter_map[QImage::NImageFormats][QImage::NImageFormats];
 
 void convert_generic(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags);
+void convert_generic_to_rgb64(QImageData *dest, const QImageData *src, Qt::ImageConversionFlags);
 bool convert_generic_inplace(QImageData *data, QImage::Format dst_format, Qt::ImageConversionFlags);
 
 void dither_to_Mono(QImageData *dst, const QImageData *src, Qt::ImageConversionFlags flags, bool fromalpha);
@@ -160,6 +161,11 @@ inline int qt_depthForFormat(QImage::Format format)
     case QImage::Format_RGB888:
         depth = 24;
         break;
+    case QImage::Format_RGBX64:
+    case QImage::Format_RGBA64:
+    case QImage::Format_RGBA64_Premultiplied:
+        depth = 64;
+        break;
     }
     return depth;
 }
diff --git a/src/gui/image/qpixmap_raster.cpp b/src/gui/image/qpixmap_raster.cpp
index 9c8835a..7a76bb2 100644
--- a/src/gui/image/qpixmap_raster.cpp
+++ b/src/gui/image/qpixmap_raster.cpp
@@ -188,8 +188,17 @@ void QRasterPlatformPixmap::fill(const QColor &color)
                     toFormat = QImage::Format_ARGB8555_Premultiplied;
                 else if (image.format() == QImage::Format_RGB444)
                     toFormat = QImage::Format_ARGB4444_Premultiplied;
+                else if (image.format() == QImage::Format_RGBX8888)
+                    toFormat = QImage::Format_RGBA8888_Premultiplied;
                 else
 #endif
+                if (image.format() == QImage::Format_BGR30)
+                    toFormat = QImage::Format_A2BGR30_Premultiplied;
+                else if (image.format() == QImage::Format_RGB30)
+                    toFormat = QImage::Format_A2RGB30_Premultiplied;
+                else if (image.format() == QImage::Format_RGBX64)
+                    toFormat = QImage::Format_RGBA64_Premultiplied;
+                else
                     toFormat = QImage::Format_ARGB32_Premultiplied;
 
                 if (!image.isNull() && qt_depthForFormat(image.format()) == qt_depthForFormat(toFormat)) {
@@ -312,7 +321,12 @@ void QRasterPlatformPixmap::createPixmapForImage(QImage &sourceImage, Qt::ImageC
         } else {
             QImage::Format opaqueFormat = QNativeImage::systemFormat();
             QImage::Format alphaFormat = QImage::Format_ARGB32_Premultiplied;
-
+#if defined(__SSE2__)
+            if (sourceImage.bitPlaneCount() > 32) {
+                opaqueFormat = QImage::Format_RGBX64;
+                alphaFormat = QImage::Format_RGBA64_Premultiplied;
+            }
+#endif
 #if !defined(__ARM_NEON__) && !defined(__SSE2__)
             switch (opaqueFormat) {
             case QImage::Format_RGB16:
